/**
 *  question4
 *  Author: bgaudou
 *  Description: 
 */

model question4

global {
	int nbTarget <- 3;
	int nbCell <- 50;

	init {
		ask nbTarget among plot {
			cover <- "target";
			color <- #black;
		}
		
		list<plot> nextPlots <- plot where (each.cover = "target");
		int dist <- 0;
		
		loop while: !empty(nextPlots) {
			rgb r_color <- rnd_color(255);
			ask nextPlots {
				distance <- dist;
				color <- r_color;	
			}
			list<plot> neighs <- remove_duplicates(nextPlots accumulate (each.neighbors));
			nextPlots <- neighs where (each.distance = -1);
			dist <- dist + 1;
		}
		
		create people number: 20 {
			my_plot <- one_of(plot);
			location <- my_plot.location;		
		}
	}
}

grid plot height: nbCell width: nbCell neighbors: 8{
	string cover <- "free";
	rgb color <- #white;
	int distance <- -1;
}

species people {
	plot my_plot ;
	
	reflex move when: (my_plot.distance != 0.0){
		plot next_p <- my_plot.neighbors with_min_of(each.distance);
		
		my_plot <- next_p;
		location <- my_plot.location;
	}
	
	aspect c {
		draw circle(1) color: #blue;
	}
}

experiment q4Exp type: gui {
	output {
		display plots {
			grid plot border: #black ;
			species people aspect: c;
		}
	}
}
