/**
 *  question5
 *  Author: bgaudou
 *  Description: 
 */

model question5

global {
	int nbTarget <- 3;
	int nbCell <- 50;

	init {
		loop i from: 0 to: int(nbCell / 2) {
			ask (plot where ((each.grid_x = i) and (each.grid_y = 10))) {
				cover <- "obstacle";
				color <- #red;				
			}
		}
		
		ask nbTarget among plot {
			cover <- "target";
			color <- #black;
		}

		ask plot {
			neigh <- (self.neighbors) where (each.cover != "obstacle");	
		}
		
		list<plot> nextPlots <- plot where (each.cover = "target");
		int dist <- 0;
		
		loop while: !empty(nextPlots) {
			rgb r_color <- rnd_color(255);
			ask nextPlots {
				distance <- dist;
				color <- r_color;	
			}
			list<plot> neighs <- remove_duplicates(nextPlots accumulate (each.neigh));
			nextPlots <- neighs where (each.distance = -1);
			dist <- dist + 1;
		}
		
		create people number: 20 {
			my_plot <- one_of(plot where (each.cover != "obstacle"));
			location <- my_plot.location;		
		}
	}
}

grid plot height: nbCell width: nbCell neighbors: 8 {
	string cover <- "free";
	rgb color <- #white;
	int distance <- -1;
	list<plot> neigh <- [];
}

species people {
	plot my_plot ;
	
	reflex move when: (my_plot.distance != 0.0){
		plot next_p <- my_plot.neigh with_min_of(each.distance);
		
		my_plot <- next_p;
		location <- my_plot.location;
	}
	
	aspect c {
		draw circle(1) color: #blue;
	}
}

experiment q5Exp type: gui {
	output {
		display plots {
			grid plot border: #black ;
			species people aspect: c;
		}
	}
}
