/**
 *  question6
 *  Author: bgaudou
 *  Description: 
 */

model question6

global {
	int nbTarget <- 3;
	int nbCell <- 50;

	list<plot> listTarget ;

	init {
		loop i from: 0 to: int(nbCell / 2) {
			ask (plot where ((each.grid_x = i) and (each.grid_y = 10))) {
				cover <- "obstacle";
				color <- #red;				
			}
		}
		
		ask nbTarget among plot {
			cover <- "target";
			color <- #black;
		}
		
		listTarget <- plot where (each.cover = "target");

		ask plot {
			neigh <- (self.neighbors) where (each.cover != "obstacle");	
						
			loop obst over: listTarget {
				add item: -1 at: obst to: distanceMap;
				add item: #white at: obst to: colorMap;				
			}
		}
		
		loop obst over: listTarget {
			list<plot> nextPlots <- [obst];
			int dist <- 0;	
			
			loop while: !empty(nextPlots) {
				rgb r_color <- rnd_color(255);
				ask nextPlots {
					distanceMap[obst] <- dist;
					colorMap[obst] <- r_color;	
				}
				list<plot> neighs <- remove_duplicates(nextPlots accumulate (each.neigh));
				nextPlots <- neighs where (each.distanceMap[obst] = -1);
				dist <- dist + 1;
			}					
		}
		
		create people number: 20 {
			my_plot <- one_of(plot where (each.cover != "obstacle"));
			location <- my_plot.location;	
			
			target <- one_of(listTarget);	
		}
	}
}

grid plot height: nbCell width: nbCell neighbors: 8 {
	string cover <- "free";
	rgb color <- #white;
	map<plot,rgb> colorMap <- map([]);
	map<plot,int> distanceMap <- map<plot,int>([]);
	list<plot> neigh <- [];
	
	aspect Target1 {
		draw square(2) color: colorMap[listTarget[0]] border: #black;
	}
	aspect Target2 {
		draw square(2) color: colorMap[listTarget[1]] border: #black;
	}
	aspect Target3 {
		draw square(2) color: colorMap[listTarget[2]] border: #black;
	}		
}

species people {
	plot my_plot ;
	plot target;
	
	reflex move when: (my_plot.distanceMap[target] != 0.0){
		plot next_p <- my_plot.neigh with_min_of(each.distanceMap[target]);
		
		my_plot <- next_p;
		location <- my_plot.location;
	} 
	
	aspect c {
		draw circle(1) color: #blue;
	}
}

experiment q6Exp type: gui {
	output {
		display plots1 {
			species plot aspect: Target1 ;
			species people aspect: c;
		}
		display plots2 {
			species plot aspect: Target2 ;
			species people aspect: c;
		}
		display plots3 {
			species plot aspect: Target3 ;
			species people aspect: c;
		}				
	}
}
